/* WARNING: THIS FILE IS AUTOMATICALLY GENERATED FROM A .SM FILE.
 * Changes made here will certainly be overwritten.
 */

/* 
 * (C) 2003 Clemson University and The University of Chicago 
 *
 * See COPYING in top-level directory.
 */

/** \file
 *  \ingroup sysint
 *
 *  PVFS2 system interface routines for reading entries from a directory.
 */
#include <string.h>
#include <assert.h>

#include "client-state-machine.h"
#include "pvfs2-debug.h"
#include "job.h"
#include "gossip.h"
#include "str-utils.h"
#include "pint-cached-config.h"
#include "PINT-reqproto-encode.h"
#include "ncache.h"
#include "pint-util.h"
#include "pvfs2-internal.h"

extern job_context_id pint_client_sm_context;

static int readdir_msg_comp_fn(
    void *v_p, struct PVFS_server_resp *resp_p, int index);


static PINT_sm_action readdir_init(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_init;
static struct PINT_pjmp_tbl_s ST_init_pjtbl[];
static struct PINT_tran_tbl_s ST_init_trtbl[];
static struct PINT_state_s ST_readdir_getattr;
static struct PINT_pjmp_tbl_s ST_readdir_getattr_pjtbl[];
static struct PINT_tran_tbl_s ST_readdir_getattr_trtbl[];

static PINT_sm_action readdir_msg_setup_msgpair(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_readdir_msg_setup_msgpair;
static struct PINT_pjmp_tbl_s ST_readdir_msg_setup_msgpair_pjtbl[];
static struct PINT_tran_tbl_s ST_readdir_msg_setup_msgpair_trtbl[];
static struct PINT_state_s ST_readdir_msg_xfer_msgpair;
static struct PINT_pjmp_tbl_s ST_readdir_msg_xfer_msgpair_pjtbl[];
static struct PINT_tran_tbl_s ST_readdir_msg_xfer_msgpair_trtbl[];

static PINT_sm_action readdir_msg_failure(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_readdir_msg_failure;
static struct PINT_pjmp_tbl_s ST_readdir_msg_failure_pjtbl[];
static struct PINT_tran_tbl_s ST_readdir_msg_failure_trtbl[];

static PINT_sm_action readdir_cleanup(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_cleanup;
static struct PINT_pjmp_tbl_s ST_cleanup_pjtbl[];
static struct PINT_tran_tbl_s ST_cleanup_trtbl[];

struct PINT_state_machine_s pvfs2_client_readdir_sm = {
	.name = "pvfs2_client_readdir_sm",
	.first_state = &ST_init
};

static struct PINT_state_s ST_init = {
	 .state_name = "init" ,
	 .parent_machine = &pvfs2_client_readdir_sm ,
	 .flag = SM_RUN ,
	 .action.func = readdir_init ,
	 .pjtbl = NULL ,
	 .trtbl = ST_init_trtbl 
};

static struct PINT_tran_tbl_s ST_init_trtbl[] = {
	{ .return_value = -1 ,
	 .next_state = &ST_readdir_getattr }
};

static struct PINT_state_s ST_readdir_getattr = {
	 .state_name = "readdir_getattr" ,
	 .parent_machine = &pvfs2_client_readdir_sm ,
	 .flag = SM_JUMP ,
	 .action.nested = &pvfs2_client_getattr_sm ,
	 .pjtbl = NULL ,
	 .trtbl = ST_readdir_getattr_trtbl 
};

static struct PINT_tran_tbl_s ST_readdir_getattr_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_readdir_msg_setup_msgpair },
	{ .return_value = -1 ,
	 .next_state = &ST_cleanup }
};

static struct PINT_state_s ST_readdir_msg_setup_msgpair = {
	 .state_name = "readdir_msg_setup_msgpair" ,
	 .parent_machine = &pvfs2_client_readdir_sm ,
	 .flag = SM_RUN ,
	 .action.func = readdir_msg_setup_msgpair ,
	 .pjtbl = NULL ,
	 .trtbl = ST_readdir_msg_setup_msgpair_trtbl 
};

static struct PINT_tran_tbl_s ST_readdir_msg_setup_msgpair_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_readdir_msg_xfer_msgpair },
	{ .return_value = -1 ,
	 .next_state = &ST_readdir_msg_failure }
};

static struct PINT_state_s ST_readdir_msg_xfer_msgpair = {
	 .state_name = "readdir_msg_xfer_msgpair" ,
	 .parent_machine = &pvfs2_client_readdir_sm ,
	 .flag = SM_JUMP ,
	 .action.nested = &pvfs2_msgpairarray_sm ,
	 .pjtbl = NULL ,
	 .trtbl = ST_readdir_msg_xfer_msgpair_trtbl 
};

static struct PINT_tran_tbl_s ST_readdir_msg_xfer_msgpair_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_cleanup },
	{ .return_value = -1 ,
	 .next_state = &ST_readdir_msg_failure }
};

static struct PINT_state_s ST_readdir_msg_failure = {
	 .state_name = "readdir_msg_failure" ,
	 .parent_machine = &pvfs2_client_readdir_sm ,
	 .flag = SM_RUN ,
	 .action.func = readdir_msg_failure ,
	 .pjtbl = NULL ,
	 .trtbl = ST_readdir_msg_failure_trtbl 
};

static struct PINT_tran_tbl_s ST_readdir_msg_failure_trtbl[] = {
	{ .return_value = -1 ,
	 .next_state = &ST_cleanup }
};

static struct PINT_state_s ST_cleanup = {
	 .state_name = "cleanup" ,
	 .parent_machine = &pvfs2_client_readdir_sm ,
	 .flag = SM_RUN ,
	 .action.func = readdir_cleanup ,
	 .pjtbl = NULL ,
	 .trtbl = ST_cleanup_trtbl 
};

static struct PINT_tran_tbl_s ST_cleanup_trtbl[] = {
	{ .return_value = -1 ,
	 .flag = SM_RETURN }
};

static struct PINT_state_s ST_dowork;
static struct PINT_pjmp_tbl_s ST_dowork_pjtbl[];
static struct PINT_tran_tbl_s ST_dowork_trtbl[];

static PINT_sm_action do_cleanup(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_do_cleanup;
static struct PINT_pjmp_tbl_s ST_do_cleanup_pjtbl[];
static struct PINT_tran_tbl_s ST_do_cleanup_trtbl[];

struct PINT_state_machine_s pvfs2_client_sysint_readdir_sm = {
	.name = "pvfs2_client_sysint_readdir_sm",
	.first_state = &ST_dowork
};

static struct PINT_state_s ST_dowork = {
	 .state_name = "dowork" ,
	 .parent_machine = &pvfs2_client_sysint_readdir_sm ,
	 .flag = SM_JUMP ,
	 .action.nested = &pvfs2_client_readdir_sm ,
	 .pjtbl = NULL ,
	 .trtbl = ST_dowork_trtbl 
};

static struct PINT_tran_tbl_s ST_dowork_trtbl[] = {
	{ .return_value = -1 ,
	 .next_state = &ST_do_cleanup }
};

static struct PINT_state_s ST_do_cleanup = {
	 .state_name = "do_cleanup" ,
	 .parent_machine = &pvfs2_client_sysint_readdir_sm ,
	 .flag = SM_RUN ,
	 .action.func = do_cleanup ,
	 .pjtbl = NULL ,
	 .trtbl = ST_do_cleanup_trtbl 
};

static struct PINT_tran_tbl_s ST_do_cleanup_trtbl[] = {
	{ .return_value = -1 ,

	 .flag = SM_TERM }
};

# 89 "src/client/sysint/sys-readdir.sm"


/** Initiate reading of entries from a directory.
 *
 *  \param token opaque value used to track position in directory
 *         when more than one read is required.
 *  \param pvfs_dirent_incount maximum number of entries to read, if
 *         available, starting from token.
 */
PVFS_error PVFS_isys_readdir(
    PVFS_object_ref ref,
    PVFS_ds_position token, 
    int32_t pvfs_dirent_incount,
    const PVFS_credentials *credentials,
    PVFS_sysresp_readdir *resp,
    PVFS_sys_op_id *op_id,
    void *user_ptr)
{
    PVFS_error ret = -PVFS_EINVAL;
    PINT_smcb *smcb = NULL;
    PINT_client_sm *sm_p = NULL;

    gossip_debug(GOSSIP_CLIENT_DEBUG, "PVFS_isys_readdir entered\n");

    if ((ref.handle == PVFS_HANDLE_NULL) ||
        (ref.fs_id == PVFS_FS_ID_NULL) ||
        (resp == NULL))
    {
        gossip_err("invalid (NULL) required argument\n");
        return ret;
    }

    if (pvfs_dirent_incount > PVFS_REQ_LIMIT_DIRENT_COUNT)
    {
        gossip_lerr("PVFS_isys_readdir unable to handle request "
                    "for %d entries.\n", pvfs_dirent_incount);
        return ret;
    }

    PINT_smcb_alloc(&smcb, PVFS_SYS_READDIR,
             sizeof(struct PINT_client_sm),
             client_op_state_get_machine,
             client_state_machine_terminate,
             pint_client_sm_context);
    if (smcb == NULL)
    {
        return -PVFS_ENOMEM;
    }
    sm_p = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);

    PINT_init_msgarray_params(&sm_p->msgarray_params, ref.fs_id);
    PINT_init_sysint_credentials(sm_p->cred_p, credentials);
    sm_p->u.readdir.readdir_resp = resp;
    sm_p->object_ref = ref;
    /* point the sm dirent array and outcount to the readdir response field */
    sm_p->readdir.dirent_array = &resp->dirent_array;
    sm_p->readdir.dirent_outcount = &resp->pvfs_dirent_outcount;
    sm_p->readdir.token = &resp->token;
    sm_p->readdir.directory_version = &resp->directory_version;

    sm_p->readdir.pos_token = sm_p->u.readdir.pos_token = token;
    sm_p->readdir.dirent_limit = sm_p->u.readdir.dirent_limit = pvfs_dirent_incount;

    gossip_debug(GOSSIP_READDIR_DEBUG, "Doing readdir on handle "
                 "%llu on fs %d\n", llu(ref.handle), ref.fs_id);

    return PINT_client_state_machine_post(
        smcb,  op_id, user_ptr);
}

/** Read entries from a directory.
 *
 *  \param token opaque value used to track position in directory
 *         when more than one read is required.
 *  \param pvfs_dirent_incount maximum number of entries to read, if
 *         available, starting from token.
 */
PVFS_error PVFS_sys_readdir(
    PVFS_object_ref ref,
    PVFS_ds_position token, 
    int32_t pvfs_dirent_incount,
    const PVFS_credentials *credentials,
    PVFS_sysresp_readdir *resp)
{
    PVFS_error ret = -PVFS_EINVAL, error = 0;
    PVFS_sys_op_id op_id;

    gossip_debug(GOSSIP_CLIENT_DEBUG, "PVFS_sys_readdir entered\n");

    ret = PVFS_isys_readdir(ref, token, pvfs_dirent_incount,
                            credentials, resp, &op_id, NULL);
    if (ret)
    {
        PVFS_perror_gossip("PVFS_isys_readdir call", ret);
        error = ret;
    }
    else
    {
        ret = PVFS_sys_wait(op_id, "readdir", &error);
        if (ret)
        {
            PVFS_perror_gossip("PVFS_sys_wait call", ret);
            error = ret;
        }
    }

    PINT_sys_release(op_id);
    return error;
}

/****************************************************************/

static PINT_sm_action readdir_init(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_client_sm *sm_p = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    gossip_debug(GOSSIP_CLIENT_DEBUG, "readdir state: init\n");

    PINT_SM_GETATTR_STATE_FILL(
        sm_p->getattr,
        sm_p->object_ref,
        PVFS_ATTR_DIR_ALL,
        PVFS_TYPE_DIRECTORY,
        0);
    
    assert(js_p->error_code == 0);

    return SM_ACTION_COMPLETE;
}

static PINT_sm_action readdir_msg_setup_msgpair(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_client_sm *sm_p = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    int ret = -PVFS_EINVAL;
    PINT_sm_msgpair_state *msg_p = NULL;

    gossip_debug(GOSSIP_CLIENT_DEBUG, "readdir state: "
                 "readdir_msg_setup_msgpair\n");

    if (js_p->error_code)
    {
        return SM_ACTION_COMPLETE;
    }
    js_p->error_code = 0;

    gossip_debug(GOSSIP_READDIR_DEBUG," readdir: posting readdir req\n");

    gossip_debug(
        GOSSIP_READDIR_DEBUG, "%llu|%d | token is %llu | limit is %d\n",
        llu(sm_p->object_ref.handle),
        sm_p->object_ref.fs_id,
        llu(sm_p->readdir.pos_token),
        sm_p->readdir.dirent_limit);

    PINT_init_msgpair(sm_p, msg_p);

    PINT_SERVREQ_READDIR_FILL(
        msg_p->req,
        *sm_p->cred_p,
        sm_p->object_ref.fs_id,
        sm_p->object_ref.handle,
        sm_p->readdir.pos_token,
        sm_p->readdir.dirent_limit);

    msg_p->fs_id = sm_p->object_ref.fs_id;
    msg_p->handle = sm_p->object_ref.handle;
    msg_p->retry_flag = PVFS_MSGPAIR_RETRY;
    msg_p->comp_fn = readdir_msg_comp_fn;

    ret = PINT_cached_config_map_to_server(
        &msg_p->svr_addr, sm_p->object_ref.handle,
        sm_p->object_ref.fs_id);

    if (ret)
    {
        gossip_err("Failed to map meta server address\n");
        js_p->error_code = ret;
    }
    return SM_ACTION_COMPLETE;
}

static int readdir_msg_comp_fn(void *v_p,
                               struct PVFS_server_resp *resp_p,
                               int index)
{
    PINT_smcb *smcb = v_p;
    PINT_client_sm *sm_p = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    
    gossip_debug(GOSSIP_CLIENT_DEBUG, "readdir_msg_comp_fn\n");

    assert(resp_p->op == PVFS_SERV_READDIR);

    if (resp_p->status != 0)
    {
	return resp_p->status;
    }

    /* convert servresp_readdir response to a sysresp_readdir obj */

    *(sm_p->readdir.token) = resp_p->u.readdir.token;
    *(sm_p->readdir.directory_version) =
        resp_p->u.readdir.directory_version;
    *(sm_p->readdir.dirent_outcount) =
        resp_p->u.readdir.dirent_count;
    if (*(sm_p->readdir.dirent_outcount) > 0)
    {
        int dirent_array_len =
            (sizeof(PVFS_dirent) * *(sm_p->readdir.dirent_outcount));

        /* this dirent_array MUST be freed by caller */
        *(sm_p->readdir.dirent_array) =
            (PVFS_dirent *) malloc(dirent_array_len);
        assert(*(sm_p->readdir.dirent_array));

        memcpy(*(sm_p->readdir.dirent_array),
               resp_p->u.readdir.dirent_array, dirent_array_len);
    }

    gossip_debug(GOSSIP_READDIR_DEBUG, "*** Got %d directory entries "
                 "[version %lld]\n",
                 *(sm_p->readdir.dirent_outcount),
                 lld(*(sm_p->readdir.directory_version)));

    return 0;
}

static PINT_sm_action readdir_msg_failure(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    gossip_debug(GOSSIP_CLIENT_DEBUG,
                 "readdir state: readdir_msg_failure\n");
    return SM_ACTION_COMPLETE;
}

static PINT_sm_action readdir_cleanup(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_client_sm *sm_p = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    int i = 0;
    PVFS_object_ref tmp_ref;
    gossip_debug(GOSSIP_CLIENT_DEBUG, "readdir state: cleanup\n");

    if(js_p->error_code == 0)
    {
        /* insert all handles into the ncache while we have them */
        tmp_ref.fs_id = sm_p->object_ref.fs_id;
        for(i = 0; i < *(sm_p->readdir.dirent_outcount); i++)
        {
            tmp_ref.handle = (*(sm_p->readdir.dirent_array))[i].handle;
            PINT_ncache_update(
                (const char *) (*(sm_p->readdir.dirent_array))[i].d_name,
                (const PVFS_object_ref *) &(tmp_ref),
                (const PVFS_object_ref *) &(sm_p->object_ref));
        }
    }

    PINT_SM_GETATTR_STATE_CLEAR(sm_p->getattr);

    if(js_p->error_code != 0)
    {
        PINT_acache_invalidate(sm_p->object_ref);
    }
    return SM_ACTION_COMPLETE;
}

static PINT_sm_action do_cleanup(
        struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_client_sm *sm_p = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    gossip_debug(GOSSIP_CLIENT_DEBUG, "readdir state: do_cleanup\n");

    sm_p->error_code = js_p->error_code;
    gossip_debug(GOSSIP_READDIR_DEBUG, " final return code is %d\n",
                 sm_p->error_code);

    PINT_SET_OP_COMPLETE;
    return SM_ACTION_TERMINATE;
}



/*
 * Local variables:
 *  mode: c
 *  c-indent-level: 4
 *  c-basic-offset: 4
 * End:
 *
 * vim: ft=c ts=8 sts=4 sw=4 expandtab
 */
