/* WARNING: THIS FILE IS AUTOMATICALLY GENERATED FROM A .SM FILE.
 * Changes made here will certainly be overwritten.
 */

/* 
 * (C) 2003 Clemson University and The University of Chicago 
 *
 * See COPYING in top-level directory.
 */

/** \file
 *  \ingroup sysint
 *
 *  PVFS2 system interface routines for modifying the size of a file,
 *  either growing or shrinking.
 */
#include <string.h>
#include <assert.h>

#include "client-state-machine.h"
#include "pvfs2-debug.h"
#include "job.h"
#include "gossip.h"
#include "str-utils.h"
#include "pint-util.h"
#include "pint-request.h"
#include "pint-cached-config.h"
#include "PINT-reqproto-encode.h"
#include "acache.h"
#include "pvfs2-internal.h"

extern job_context_id pint_client_sm_context;

static struct PINT_state_s ST_truncate_getattr;
static struct PINT_pjmp_tbl_s ST_truncate_getattr_pjtbl[];
static struct PINT_tran_tbl_s ST_truncate_getattr_trtbl[];

static PINT_sm_action truncate_datafile_setup_msgpairarray(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_truncate_datafile_setup_msgpairarray;
static struct PINT_pjmp_tbl_s ST_truncate_datafile_setup_msgpairarray_pjtbl[];
static struct PINT_tran_tbl_s ST_truncate_datafile_setup_msgpairarray_trtbl[];
static struct PINT_state_s ST_truncate_datafile_xfer_msgpairarray;
static struct PINT_pjmp_tbl_s ST_truncate_datafile_xfer_msgpairarray_pjtbl[];
static struct PINT_tran_tbl_s ST_truncate_datafile_xfer_msgpairarray_trtbl[];

static PINT_sm_action truncate_datafile_failure(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_truncate_datafile_failure;
static struct PINT_pjmp_tbl_s ST_truncate_datafile_failure_pjtbl[];
static struct PINT_tran_tbl_s ST_truncate_datafile_failure_trtbl[];

static PINT_sm_action truncate_cleanup(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_cleanup;
static struct PINT_pjmp_tbl_s ST_cleanup_pjtbl[];
static struct PINT_tran_tbl_s ST_cleanup_trtbl[];

struct PINT_state_machine_s pvfs2_client_truncate_sm = {
	.name = "pvfs2_client_truncate_sm",
	.first_state = &ST_truncate_getattr
};

static struct PINT_state_s ST_truncate_getattr = {
	 .state_name = "truncate_getattr" ,
	 .parent_machine = &pvfs2_client_truncate_sm ,
	 .flag = SM_JUMP ,
	 .action.nested = &pvfs2_client_getattr_sm ,
	 .pjtbl = NULL ,
	 .trtbl = ST_truncate_getattr_trtbl 
};

static struct PINT_tran_tbl_s ST_truncate_getattr_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_truncate_datafile_setup_msgpairarray },
	{ .return_value = -1 ,
	 .next_state = &ST_cleanup }
};

static struct PINT_state_s ST_truncate_datafile_setup_msgpairarray = {
	 .state_name = "truncate_datafile_setup_msgpairarray" ,
	 .parent_machine = &pvfs2_client_truncate_sm ,
	 .flag = SM_RUN ,
	 .action.func = truncate_datafile_setup_msgpairarray ,
	 .pjtbl = NULL ,
	 .trtbl = ST_truncate_datafile_setup_msgpairarray_trtbl 
};

static struct PINT_tran_tbl_s ST_truncate_datafile_setup_msgpairarray_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_truncate_datafile_xfer_msgpairarray },
	{ .return_value = -1 ,
	 .next_state = &ST_cleanup }
};

static struct PINT_state_s ST_truncate_datafile_xfer_msgpairarray = {
	 .state_name = "truncate_datafile_xfer_msgpairarray" ,
	 .parent_machine = &pvfs2_client_truncate_sm ,
	 .flag = SM_JUMP ,
	 .action.nested = &pvfs2_msgpairarray_sm ,
	 .pjtbl = NULL ,
	 .trtbl = ST_truncate_datafile_xfer_msgpairarray_trtbl 
};

static struct PINT_tran_tbl_s ST_truncate_datafile_xfer_msgpairarray_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_cleanup },
	{ .return_value = -1 ,
	 .next_state = &ST_truncate_datafile_failure }
};

static struct PINT_state_s ST_truncate_datafile_failure = {
	 .state_name = "truncate_datafile_failure" ,
	 .parent_machine = &pvfs2_client_truncate_sm ,
	 .flag = SM_RUN ,
	 .action.func = truncate_datafile_failure ,
	 .pjtbl = NULL ,
	 .trtbl = ST_truncate_datafile_failure_trtbl 
};

static struct PINT_tran_tbl_s ST_truncate_datafile_failure_trtbl[] = {
	{ .return_value = -1 ,
	 .next_state = &ST_cleanup }
};

static struct PINT_state_s ST_cleanup = {
	 .state_name = "cleanup" ,
	 .parent_machine = &pvfs2_client_truncate_sm ,
	 .flag = SM_RUN ,
	 .action.func = truncate_cleanup ,
	 .pjtbl = NULL ,
	 .trtbl = ST_cleanup_trtbl 
};

static struct PINT_tran_tbl_s ST_cleanup_trtbl[] = {
	{ .return_value = -1 ,

	 .flag = SM_TERM }
};

# 68 "src/client/sysint/sys-truncate.sm"


/** Initiate resizing of a file.
 */
PVFS_error PVFS_isys_truncate(
    PVFS_object_ref ref,
    PVFS_size size,
    const PVFS_credentials *credentials,
    PVFS_sys_op_id *op_id,
    void *user_ptr)
{
    PVFS_error ret = -PVFS_EINVAL;
    PINT_smcb *smcb = NULL;
    PINT_client_sm *sm_p = NULL;

    if ((ref.fs_id == PVFS_FS_ID_NULL) ||
        (ref.handle == PVFS_HANDLE_NULL))
    {
        gossip_err("invalid (NULL) required argument\n");
        return ret;
    }

    if (size < 0)
    {
        gossip_err("invalid size (negative) specified: %lld\n", lld(size));
        return ret;
    }

    gossip_debug(GOSSIP_CLIENT_DEBUG,
                 "PVFS_isys_truncate entered with %lld\n", lld(size));

    PINT_smcb_alloc(&smcb, PVFS_SYS_TRUNCATE,
             sizeof(struct PINT_client_sm),
             client_op_state_get_machine,
             client_state_machine_terminate,
             pint_client_sm_context);
    if (smcb == NULL)
    {
        return -PVFS_ENOMEM;
    }
    sm_p = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);

    PINT_init_msgarray_params(&sm_p->msgarray_params, ref.fs_id);
    PINT_init_sysint_credentials(sm_p->cred_p, credentials);
    sm_p->u.truncate.size = size;
    sm_p->object_ref = ref;

    PINT_SM_GETATTR_STATE_FILL(
        sm_p->getattr,
        sm_p->object_ref,
        PVFS_ATTR_META_ALL|PVFS_ATTR_COMMON_TYPE,
        PVFS_TYPE_METAFILE,
        0);

    return PINT_client_state_machine_post(
        smcb,  op_id, user_ptr);
}

PVFS_error PVFS_sys_truncate(
    PVFS_object_ref ref,
    PVFS_size size,
    const PVFS_credentials *credentials)
{
    PVFS_error ret = -PVFS_EINVAL, error = 0;
    PVFS_sys_op_id op_id;

    gossip_debug(GOSSIP_CLIENT_DEBUG,
                 "PVFS_sys_truncate entered with %lld\n", lld(size));

    ret = PVFS_isys_truncate(ref, size, credentials, &op_id, NULL);
    if (ret)
    {
        PVFS_perror_gossip("PVFS_isys_truncate call", ret);
        error = ret;
    }
    else
    {
        ret = PVFS_sys_wait(op_id, "truncate", &error);
        if (ret)
        {
            PVFS_perror_gossip("PVFS_sys_wait call", ret);
            error = ret;
        }
    }

    PINT_sys_release(op_id);
    return error;
}

/** Resize a file.
 */
static PINT_sm_action truncate_datafile_setup_msgpairarray(
    struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_client_sm *sm_p = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    int ret = -PVFS_EINVAL, i = 0;
    PVFS_object_attr *attr = NULL;
    PINT_sm_msgpair_state *msg_p = NULL;
    PVFS_size new_dfile_size = 0;
    PINT_request_file_data file_data;
    
    js_p->error_code = 0;

    attr = &sm_p->getattr.attr;
    assert(attr);

    assert(attr->mask & PVFS_ATTR_META_DFILES);
    assert(attr->mask & PVFS_ATTR_META_DIST);
    assert(attr->u.meta.dfile_count > 0);
    assert(attr->u.meta.dist_size > 0);
    /* cannot truncate an append-only or immutable file */
    if ((attr->u.meta.hint.flags & PVFS_IMMUTABLE_FL)
        || (attr->u.meta.hint.flags & PVFS_APPEND_FL))
    {
        js_p->error_code = -PVFS_EPERM;
        return 1;
    }

    sm_p->msgarray_count = attr->u.meta.dfile_count;

    sm_p->msgarray = (PINT_sm_msgpair_state *)malloc(
        sm_p->msgarray_count * sizeof(PINT_sm_msgpair_state));
    if (!sm_p->msgarray)
    {
        js_p->error_code = -PVFS_ENOMEM;
        return SM_ACTION_COMPLETE;
    }

    /* Initialize the file data struct */
    memset(&file_data, 0, sizeof(file_data));
    file_data.dist = attr->u.meta.dist;
    file_data.server_ct = attr->u.meta.dfile_count;
    file_data.extend_flag = 1;

    /* Construct truncate messages */
    for (i = 0; i < attr->u.meta.dfile_count; i++)
    {
        msg_p = &sm_p->msgarray[i];

        file_data.server_nr = i;
        new_dfile_size = 
            attr->u.meta.dist->methods->logical_to_physical_offset(
                attr->u.meta.dist->params,
                &file_data,
                sm_p->u.truncate.size);
       
        gossip_debug(GOSSIP_CLIENT_DEBUG,
            "  %s: client requests %lld: resizing %lld to %lld bytes\n",
            __func__, lld(sm_p->u.truncate.size),
            llu(attr->u.meta.dfile_array[i]), lld(new_dfile_size));

        PINT_SERVREQ_TRUNCATE_FILL(
            msg_p->req,
            *sm_p->cred_p,
            sm_p->object_ref.fs_id,
            new_dfile_size,
            attr->u.meta.dfile_array[i]);
        /*
          no callback. the status will be in the generic response
          structure
        */
        msg_p->fs_id = sm_p->object_ref.fs_id;
        msg_p->handle = attr->u.meta.dfile_array[i];
        msg_p->retry_flag = PVFS_MSGPAIR_RETRY;
        msg_p->comp_fn = NULL;
    }

    sm_p->getattr.size = sm_p->u.truncate.size;
    ret = PINT_serv_msgpairarray_resolve_addrs(
        sm_p->msgarray_count, sm_p->msgarray);

    if (ret)
    {
        gossip_err("Error: failed to resolve server addresses.\n");
        js_p->error_code = ret;
    }
    return SM_ACTION_COMPLETE;
}

static PINT_sm_action truncate_datafile_failure(
    struct PINT_smcb *smcb, job_status_s *js_p)
{
    return SM_ACTION_COMPLETE;
}

static PINT_sm_action truncate_cleanup(
    struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_client_sm *sm_p = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    sm_p->error_code = js_p->error_code;

    if (sm_p->msgarray && (sm_p->msgarray != &sm_p->msgpair))
    {
        free(sm_p->msgarray);
        sm_p->msgarray = NULL;
    }

    if(sm_p->error_code == 0)
    {
        PINT_acache_invalidate_size(sm_p->object_ref);
    }
    else
    {
        PINT_acache_invalidate(sm_p->object_ref);
    }

    PINT_SM_GETATTR_STATE_CLEAR(sm_p->getattr);

    PINT_SET_OP_COMPLETE;
    return SM_ACTION_TERMINATE;
}

/*
 * Local variables:
 *  mode: c
 *  c-indent-level: 4
 *  c-basic-offset: 4
 * End:
 *
 * vim: ft=c ts=8 sts=4 sw=4 expandtab
 */
