/* WARNING: THIS FILE IS AUTOMATICALLY GENERATED FROM A .SM FILE.
 * Changes made here will certainly be overwritten.
 */

/* 
 * (C) 2001 Clemson University and The University of Chicago 
 *
 * See COPYING in top-level directory.
 *
 */

/* pvfs2_list_attr_sm
 *
 * This state machine handles incoming server listattr operations for a list of handles.  These
 * are the operations sent by PVFS_sys_readdirplus().
 *
 */

#include <string.h>
#include <assert.h>

#include "server-config.h"
#include "pvfs2-server.h"
#include "pvfs2-attr.h"
#include "pvfs2-types.h"
#include "pvfs2-types-debug.h"
#include "pvfs2-util.h"
#include "pint-util.h"
#include "pvfs2-internal.h"

enum
{
    STATE_METAFILE = 7,
    STATE_SYMLINK  = 9,
    STATE_DIR      = 10
};

enum 
{
    MORE_WORK = 1,
};


static PINT_sm_action listattr_verify_attribs(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_verify_attribs;
static struct PINT_pjmp_tbl_s ST_verify_attribs_pjtbl[];
static struct PINT_tran_tbl_s ST_verify_attribs_trtbl[];

static PINT_sm_action listattr_read_symlink_target(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_read_symlink_target;
static struct PINT_pjmp_tbl_s ST_read_symlink_target_pjtbl[];
static struct PINT_tran_tbl_s ST_read_symlink_target_trtbl[];

static PINT_sm_action listattr_read_metafile_datafile_handles_if_required(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_read_metafile_datafile_handles_if_required;
static struct PINT_pjmp_tbl_s ST_read_metafile_datafile_handles_if_required_pjtbl[];
static struct PINT_tran_tbl_s ST_read_metafile_datafile_handles_if_required_trtbl[];

static PINT_sm_action listattr_read_metafile_distribution_if_required(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_read_metafile_distribution_if_required;
static struct PINT_pjmp_tbl_s ST_read_metafile_distribution_if_required_pjtbl[];
static struct PINT_tran_tbl_s ST_read_metafile_distribution_if_required_trtbl[];

static PINT_sm_action listattr_get_dirent_count(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_get_dirent_count;
static struct PINT_pjmp_tbl_s ST_get_dirent_count_pjtbl[];
static struct PINT_tran_tbl_s ST_get_dirent_count_trtbl[];

static PINT_sm_action listattr_interpret_dirent_count(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_interpret_dirent_count;
static struct PINT_pjmp_tbl_s ST_interpret_dirent_count_pjtbl[];
static struct PINT_tran_tbl_s ST_interpret_dirent_count_trtbl[];

static PINT_sm_action listattr_setup_resp(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_setup_resp;
static struct PINT_pjmp_tbl_s ST_setup_resp_pjtbl[];
static struct PINT_tran_tbl_s ST_setup_resp_trtbl[];

struct PINT_state_machine_s pvfs2_list_attr_work_sm = {
	.name = "pvfs2_list_attr_work_sm",
	.first_state = &ST_verify_attribs
};

static struct PINT_state_s ST_verify_attribs = {
	 .state_name = "verify_attribs" ,
	 .parent_machine = &pvfs2_list_attr_work_sm ,
	 .flag = SM_RUN ,
	 .action.func = listattr_verify_attribs ,
	 .pjtbl = NULL ,
	 .trtbl = ST_verify_attribs_trtbl 
};

static struct PINT_tran_tbl_s ST_verify_attribs_trtbl[] = {
	{ .return_value = STATE_SYMLINK ,
	 .next_state = &ST_read_symlink_target },
	{ .return_value = STATE_METAFILE ,
	 .next_state = &ST_read_metafile_datafile_handles_if_required },
	{ .return_value = STATE_DIR ,
	 .next_state = &ST_get_dirent_count },
	{ .return_value = -1 ,
	 .next_state = &ST_setup_resp }
};

static struct PINT_state_s ST_read_symlink_target = {
	 .state_name = "read_symlink_target" ,
	 .parent_machine = &pvfs2_list_attr_work_sm ,
	 .flag = SM_RUN ,
	 .action.func = listattr_read_symlink_target ,
	 .pjtbl = NULL ,
	 .trtbl = ST_read_symlink_target_trtbl 
};

static struct PINT_tran_tbl_s ST_read_symlink_target_trtbl[] = {
	{ .return_value = -1 ,
	 .next_state = &ST_setup_resp }
};

static struct PINT_state_s ST_read_metafile_datafile_handles_if_required = {
	 .state_name = "read_metafile_datafile_handles_if_required" ,
	 .parent_machine = &pvfs2_list_attr_work_sm ,
	 .flag = SM_RUN ,
	 .action.func = listattr_read_metafile_datafile_handles_if_required ,
	 .pjtbl = NULL ,
	 .trtbl = ST_read_metafile_datafile_handles_if_required_trtbl 
};

static struct PINT_tran_tbl_s ST_read_metafile_datafile_handles_if_required_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_read_metafile_distribution_if_required },
	{ .return_value = -1 ,
	 .next_state = &ST_setup_resp }
};

static struct PINT_state_s ST_read_metafile_distribution_if_required = {
	 .state_name = "read_metafile_distribution_if_required" ,
	 .parent_machine = &pvfs2_list_attr_work_sm ,
	 .flag = SM_RUN ,
	 .action.func = listattr_read_metafile_distribution_if_required ,
	 .pjtbl = NULL ,
	 .trtbl = ST_read_metafile_distribution_if_required_trtbl 
};

static struct PINT_tran_tbl_s ST_read_metafile_distribution_if_required_trtbl[] = {
	{ .return_value = -1 ,
	 .next_state = &ST_setup_resp }
};

static struct PINT_state_s ST_get_dirent_count = {
	 .state_name = "get_dirent_count" ,
	 .parent_machine = &pvfs2_list_attr_work_sm ,
	 .flag = SM_RUN ,
	 .action.func = listattr_get_dirent_count ,
	 .pjtbl = NULL ,
	 .trtbl = ST_get_dirent_count_trtbl 
};

static struct PINT_tran_tbl_s ST_get_dirent_count_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_interpret_dirent_count },
	{ .return_value = -1 ,
	 .next_state = &ST_setup_resp }
};

static struct PINT_state_s ST_interpret_dirent_count = {
	 .state_name = "interpret_dirent_count" ,
	 .parent_machine = &pvfs2_list_attr_work_sm ,
	 .flag = SM_RUN ,
	 .action.func = listattr_interpret_dirent_count ,
	 .pjtbl = NULL ,
	 .trtbl = ST_interpret_dirent_count_trtbl 
};

static struct PINT_tran_tbl_s ST_interpret_dirent_count_trtbl[] = {
	{ .return_value = -1 ,
	 .next_state = &ST_setup_resp }
};

static struct PINT_state_s ST_setup_resp = {
	 .state_name = "setup_resp" ,
	 .parent_machine = &pvfs2_list_attr_work_sm ,
	 .flag = SM_RUN ,
	 .action.func = listattr_setup_resp ,
	 .pjtbl = NULL ,
	 .trtbl = ST_setup_resp_trtbl 
};

static struct PINT_tran_tbl_s ST_setup_resp_trtbl[] = {
	{ .return_value = -1 ,
	 .flag = SM_RETURN }
};

static struct PINT_state_s ST_prelude;
static struct PINT_pjmp_tbl_s ST_prelude_pjtbl[];
static struct PINT_tran_tbl_s ST_prelude_trtbl[];

static PINT_sm_action listattr_setup_op(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_setup_op;
static struct PINT_pjmp_tbl_s ST_setup_op_pjtbl[];
static struct PINT_tran_tbl_s ST_setup_op_trtbl[];
static struct PINT_state_s ST_do_work;
static struct PINT_pjmp_tbl_s ST_do_work_pjtbl[];
static struct PINT_tran_tbl_s ST_do_work_trtbl[];
static struct PINT_state_s ST_final_response;
static struct PINT_pjmp_tbl_s ST_final_response_pjtbl[];
static struct PINT_tran_tbl_s ST_final_response_trtbl[];

static PINT_sm_action listattr_cleanup(
	struct PINT_smcb *smcb, job_status_s *js_p);

static struct PINT_state_s ST_cleanup;
static struct PINT_pjmp_tbl_s ST_cleanup_pjtbl[];
static struct PINT_tran_tbl_s ST_cleanup_trtbl[];

struct PINT_state_machine_s pvfs2_list_attr_sm = {
	.name = "pvfs2_list_attr_sm",
	.first_state = &ST_prelude
};

static struct PINT_state_s ST_prelude = {
	 .state_name = "prelude" ,
	 .parent_machine = &pvfs2_list_attr_sm ,
	 .flag = SM_JUMP ,
	 .action.nested = &pvfs2_prelude_sm ,
	 .pjtbl = NULL ,
	 .trtbl = ST_prelude_trtbl 
};

static struct PINT_tran_tbl_s ST_prelude_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_setup_op },
	{ .return_value = -1 ,
	 .next_state = &ST_final_response }
};

static struct PINT_state_s ST_setup_op = {
	 .state_name = "setup_op" ,
	 .parent_machine = &pvfs2_list_attr_sm ,
	 .flag = SM_RUN ,
	 .action.func = listattr_setup_op ,
	 .pjtbl = NULL ,
	 .trtbl = ST_setup_op_trtbl 
};

static struct PINT_tran_tbl_s ST_setup_op_trtbl[] = {
	{ .return_value = 0 ,
	 .next_state = &ST_do_work },
	{ .return_value = -1 ,
	 .next_state = &ST_final_response }
};

static struct PINT_state_s ST_do_work = {
	 .state_name = "do_work" ,
	 .parent_machine = &pvfs2_list_attr_sm ,
	 .flag = SM_JUMP ,
	 .action.nested = &pvfs2_list_attr_work_sm ,
	 .pjtbl = NULL ,
	 .trtbl = ST_do_work_trtbl 
};

static struct PINT_tran_tbl_s ST_do_work_trtbl[] = {
	{ .return_value = MORE_WORK ,
	 .next_state = &ST_do_work },
	{ .return_value = -1 ,
	 .next_state = &ST_final_response }
};

static struct PINT_state_s ST_final_response = {
	 .state_name = "final_response" ,
	 .parent_machine = &pvfs2_list_attr_sm ,
	 .flag = SM_JUMP ,
	 .action.nested = &pvfs2_final_response_sm ,
	 .pjtbl = NULL ,
	 .trtbl = ST_final_response_trtbl 
};

static struct PINT_tran_tbl_s ST_final_response_trtbl[] = {
	{ .return_value = -1 ,
	 .next_state = &ST_cleanup }
};

static struct PINT_state_s ST_cleanup = {
	 .state_name = "cleanup" ,
	 .parent_machine = &pvfs2_list_attr_sm ,
	 .flag = SM_RUN ,
	 .action.func = listattr_cleanup ,
	 .pjtbl = NULL ,
	 .trtbl = ST_cleanup_trtbl 
};

static struct PINT_tran_tbl_s ST_cleanup_trtbl[] = {
	{ .return_value = -1 ,

	 .flag = SM_TERM }
};

# 127 "src/server/list-attr.sm"


/* listattr_verify_attribs()
 *
 * We initialize the attribute mask that will be returned in this
 * function.  This mask can be augmented in some of the other states.
 */
static PINT_sm_action listattr_verify_attribs(
    struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_server_op *s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    PVFS_object_attr *resp_attr = NULL, *obj_attr = NULL;
    PVFS_ds_attributes *ds_attr = NULL;
    int *resp_error = NULL, *ds_error = NULL;
    PVFS_handle *handle = NULL;

    js_p->error_code = 0;

    /*
      explicitly copy basic attributes structure (read in from the
      trove_getattr_list for the matching dspace) into response to be sent
      back to the client. 
     */
    resp_attr = &s_op->resp.u.listattr.attr[s_op->u.listattr.handle_index];
    resp_error = &s_op->resp.u.listattr.error[s_op->u.listattr.handle_index];
    obj_attr  = &s_op->u.listattr.attr_a[s_op->u.listattr.handle_index];
    ds_attr   = &s_op->u.listattr.ds_attr_a[s_op->u.listattr.handle_index];
    handle    = &s_op->u.listattr.handles[s_op->u.listattr.handle_index];
    ds_error  = &s_op->u.listattr.errors[s_op->u.listattr.handle_index];
    PVFS_ds_attr_to_object_attr(ds_attr, obj_attr);
    obj_attr->mask = PVFS_ATTR_COMMON_ALL;

    *resp_error = *ds_error;
    resp_attr->owner = obj_attr->owner;
    resp_attr->group = obj_attr->group;
    resp_attr->perms = obj_attr->perms;
    resp_attr->atime = obj_attr->atime;

    resp_attr->mtime = PINT_util_mkversion_time(obj_attr->mtime);
    if (resp_attr->mtime == 0)
    {
        /*
          this is a compatibility hack to allow existing storage
          spaces to be automagically converted to this versioned time
          on-disk format slowly over time and doing the right thing in
          the meantime
        */
        resp_attr->mtime = obj_attr->mtime;

        gossip_debug(GOSSIP_LISTATTR_DEBUG, " No version found!  Using "
                     "mtime %llu\n", llu(resp_attr->mtime));
    }
    else
    {
        gossip_debug(
            GOSSIP_LISTATTR_DEBUG, " VERSION is %llu, mtime is %llu\n",
            llu(obj_attr->mtime), llu(resp_attr->mtime));
    }

    resp_attr->ctime = obj_attr->ctime;
    resp_attr->mask  = obj_attr->mask;
    resp_attr->objtype = obj_attr->objtype;
    resp_attr->u.meta.dfile_count = obj_attr->u.meta.dfile_count;
    resp_attr->u.meta.dist_size = obj_attr->u.meta.dist_size;

#if 0
    gossip_debug(
        GOSSIP_LISTATTR_DEBUG,
        "+  _DSPACE_ retrieved attrs: [owner = %d, group = %d\n\t"
        "perms = %o, type = %d, atime = %llu, mtime = %llu\n\t"
        "ctime = %llu, dfile_count = %d, dist_size = %d]\n",
        resp_attr->owner, resp_attr->group, resp_attr->perms,
        resp_attr->objtype, llu(resp_attr->atime),
        llu(resp_attr->mtime), llu(resp_attr->ctime),
        (int)resp_attr->u.meta.dfile_count,
        (int)resp_attr->u.meta.dist_size);
#endif

    /*
      weed out the attr mask of the response based on what the client
      request asked for.  also, check if we need to retrieve more
      information before returning the response to the client (by
      guiding the state machine to get it).

      we can safely do this now that we have the type of the object
      (read in from the dspace, not stored in the resp_attr), and we
      have the original client request attr mask
      (s_op->u.listattr.attrmask).
    */
    if (resp_attr->objtype == PVFS_TYPE_METAFILE)
    {
        PINT_ACCESS_DEBUG(s_op, GOSSIP_ACCESS_DEBUG, "type: metafile\n");
        gossip_debug(GOSSIP_LISTATTR_DEBUG,
                     "  Req handle %llu refers to a metafile\n",
                     llu(*handle));

        if (s_op->u.listattr.attrmask & PVFS_ATTR_META_DFILES)
        {
            gossip_debug(GOSSIP_LISTATTR_DEBUG,
                         " dspace has dfile_count of %d\n",
                         resp_attr->u.meta.dfile_count);
            resp_attr->mask |= PVFS_ATTR_META_DFILES;
        }
        else
        {
            gossip_debug(GOSSIP_LISTATTR_DEBUG, " client doesn't want "
                         "dfile info, clearing response attr mask\n");
            resp_attr->mask &= ~PVFS_ATTR_META_DFILES;
        }

        if (s_op->u.listattr.attrmask & PVFS_ATTR_META_DIST)
        {
            gossip_debug(GOSSIP_LISTATTR_DEBUG,
                         " dspace has dist size of %d\n",
                         resp_attr->u.meta.dist_size);

            resp_attr->mask |= PVFS_ATTR_META_DIST;
        }
        else
        {
            gossip_debug(GOSSIP_LISTATTR_DEBUG, " client doesn't want "
                         "dist info, clearing response attr mask\n");

            resp_attr->mask &= ~PVFS_ATTR_META_DIST;
        }

        if ((resp_attr->mask & PVFS_ATTR_META_DFILES) ||
            (resp_attr->mask & PVFS_ATTR_META_DIST))
        {
            gossip_debug(GOSSIP_LISTATTR_DEBUG, " * client wants extra "
                         "meta info, about to retrieve it now\n");
            js_p->error_code = STATE_METAFILE;
        }
        else
        {
            gossip_debug(GOSSIP_LISTATTR_DEBUG, " * client doesn't want "
                         "extra meta info, preparing response now\n");
        }
    }
    else if (resp_attr->objtype == PVFS_TYPE_DATAFILE)
    {
        PINT_ACCESS_DEBUG(s_op, GOSSIP_ACCESS_DEBUG, "type: datafile\n");
        /*
          note: the prelude already retrieved the size for us, so
          there's no special action that needs to be taken if we have
          a datafile here (other than adjusting our mask to include
          the data information and copying the retrieved size from the
          ds_attribute the prelude used)
        */
        resp_attr->u.data.size = ds_attr->b_size;
        resp_attr->mask |= PVFS_ATTR_DATA_ALL;

	gossip_debug(GOSSIP_LISTATTR_DEBUG, "  handle %llu refers to "
                     "a datafile (size = %lld).\n",
                     llu(*handle),
                     lld(resp_attr->u.data.size));
    }
    else if (resp_attr->objtype == PVFS_TYPE_DIRECTORY)
    {
        PINT_ACCESS_DEBUG(s_op, GOSSIP_ACCESS_DEBUG, "type: directory\n");
        if (s_op->u.listattr.attrmask & PVFS_ATTR_DIR_DIRENT_COUNT)
        {
            gossip_debug(GOSSIP_LISTATTR_DEBUG,
                         " listattr: dirent_count needed.\n");
            assert(resp_attr->mask & PVFS_ATTR_COMMON_ALL);
            resp_attr->mask |= PVFS_ATTR_DIR_DIRENT_COUNT;
            js_p->error_code = STATE_DIR;
        }
        else
        {
            gossip_debug(GOSSIP_LISTATTR_DEBUG,
                         " listattr: dirent_count not needed.\n");
            js_p->error_code = 0;
            assert(resp_attr->mask & PVFS_ATTR_COMMON_ALL);
        }
    }
    else if (resp_attr->objtype == PVFS_TYPE_DIRDATA)
    {
        PINT_ACCESS_DEBUG(s_op, GOSSIP_ACCESS_DEBUG, "type: dirdata\n");
	gossip_debug(
            GOSSIP_LISTATTR_DEBUG, "  handle %llu refers to "
            "a dirdata object. doing nothing special\n",
            llu(*handle));
        assert(resp_attr->mask & PVFS_ATTR_COMMON_ALL);
    }
    else if (resp_attr->objtype == PVFS_TYPE_SYMLINK)
    {
        PINT_ACCESS_DEBUG(s_op, GOSSIP_ACCESS_DEBUG, "type: symlink\n");
	gossip_debug(
            GOSSIP_LISTATTR_DEBUG, "  handle %llu refers to a symlink.\n",
            llu(*handle));

        /*
          we'll definitely have to fetch the symlink target in this
          case, as the prelude will never retrieve it for us
        */
        js_p->error_code = STATE_SYMLINK;
    }
    else
    {
	gossip_debug(
            GOSSIP_LISTATTR_DEBUG, "  handle %llu refers to something "
            "unknown -- assuming datafile!\n",
            llu(*handle));

        resp_attr->objtype = PVFS_TYPE_DATAFILE;
        resp_attr->u.data.size = ds_attr->b_size;
        resp_attr->mask |= (PVFS_ATTR_COMMON_TYPE | PVFS_ATTR_DATA_ALL);

	gossip_debug(GOSSIP_LISTATTR_DEBUG, "  handle %llu now refers to "
                     "a datafile (size = %lld).\n",
                     llu(*handle),
                     lld(resp_attr->u.data.size));
    }
    return SM_ACTION_COMPLETE;
}

static PINT_sm_action listattr_read_symlink_target(
    struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_server_op *s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    int ret;
    job_id_t i;
    PVFS_object_attr *resp_attr = NULL;
    PVFS_handle *handle = NULL;

    resp_attr = &s_op->resp.u.listattr.attr[s_op->u.listattr.handle_index];
    handle    = &s_op->u.listattr.handles[s_op->u.listattr.handle_index];


    js_p->error_code = 0;
    /* if we don't need to fill in the symlink target, skip it */
    if (!(s_op->u.listattr.attrmask & PVFS_ATTR_SYMLNK_TARGET))
    {
        gossip_debug(GOSSIP_LISTATTR_DEBUG, "skipping symlink target read\n");
        return SM_ACTION_COMPLETE;
    }

    s_op->key.buffer    = Trove_Common_Keys[SYMLINK_TARGET_KEY].key;
    s_op->key.buffer_sz = Trove_Common_Keys[SYMLINK_TARGET_KEY].size;

    /*
      optimistically add mask value to indicate the symlink target is
      filled (error_code is checked in next state)
    */
    resp_attr->mask |= PVFS_ATTR_SYMLNK_TARGET;

    resp_attr->u.sym.target_path_len = PVFS_NAME_MAX;
    resp_attr->u.sym.target_path =
	malloc(resp_attr->u.sym.target_path_len);
    if (!resp_attr->u.sym.target_path)
    {
        js_p->error_code = -PVFS_ENOMEM;
	return SM_ACTION_COMPLETE;
    }

    s_op->val.buffer = resp_attr->u.sym.target_path;
    s_op->val.buffer_sz = resp_attr->u.sym.target_path_len;

    ret = job_trove_keyval_read(
        s_op->u.listattr.fs_id, *handle,
        &(s_op->key), &(s_op->val), 
        0, NULL, smcb, 0, js_p,
        &i, server_job_context);

    return ret;
}


static PINT_sm_action listattr_read_metafile_datafile_handles_if_required(
    struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_server_op *s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    int ret = -PVFS_EINVAL;
    int dfile_count = 0;
    job_id_t i;
    PVFS_object_attr *resp_attr = NULL;
    PVFS_handle *handle = NULL;


    resp_attr = &s_op->resp.u.listattr.attr[s_op->u.listattr.handle_index];
    handle    = &s_op->u.listattr.handles[s_op->u.listattr.handle_index];
    assert(resp_attr->objtype == PVFS_TYPE_METAFILE);

    js_p->error_code = 0;

    /* if we don't need to fill in the dfiles, skip them */
    if (!(s_op->u.listattr.attrmask & PVFS_ATTR_META_DFILES))
    {
        gossip_debug(GOSSIP_LISTATTR_DEBUG, "skipping data handle read\n");
        return SM_ACTION_COMPLETE;
    }

    dfile_count = resp_attr->u.meta.dfile_count;

    gossip_debug(GOSSIP_LISTATTR_DEBUG,
                 " request has dfile_count of %d | dspace has %d\n",
                 resp_attr->u.meta.dfile_count,
                 resp_attr->u.meta.dfile_count);

    /* verify that the retrieved dfile count is sane */
    if (!PVFS_REQ_LIMIT_DFILE_COUNT_IS_VALID(dfile_count))
    {
        gossip_err("The requested dfile count of %d is invalid; "
                   "aborting operation.\n", dfile_count);
	gossip_err(
            "+ attrs read from dspace: (owner = %d, group = %d, "
            "perms = %o, type = %d\n   atime = %lld, mtime = %lld, "
            "ctime = %lld |\n   dfile_count = %d | dist_size = %d)\n",
            resp_attr->owner,
            resp_attr->group, 
            resp_attr->perms,
            resp_attr->objtype, 
            lld(resp_attr->atime),
            lld(resp_attr->mtime), 
            lld(resp_attr->ctime),
            (int)resp_attr->u.meta.dfile_count,
            (int)resp_attr->u.meta.dist_size);

	gossip_err("handle: %llu (%llx), fsid: %d.\n",
	    llu(*handle), llu(*handle),
	    (int)s_op->u.listattr.fs_id);

        js_p->error_code = -PVFS_EOVERFLOW;
	return SM_ACTION_COMPLETE;
    }

    s_op->key.buffer = Trove_Common_Keys[METAFILE_HANDLES_KEY].key;
    s_op->key.buffer_sz = Trove_Common_Keys[METAFILE_HANDLES_KEY].size;

    /* add mask value to indicate the data file array is filled */
    resp_attr->mask |= PVFS_ATTR_META_DFILES;

    resp_attr->u.meta.dfile_array =
        malloc(dfile_count * sizeof(PVFS_handle));
    if (!resp_attr->u.meta.dfile_array)
    {
        gossip_err("Cannot allocate dfile array of count %d\n",
                   dfile_count);
	js_p->error_code = -PVFS_ENOMEM;
	return SM_ACTION_COMPLETE;
    }

    s_op->val.buffer = resp_attr->u.meta.dfile_array;
    s_op->val.buffer_sz = (dfile_count * sizeof(PVFS_handle));

    gossip_debug(GOSSIP_LISTATTR_DEBUG,
		 "  reading %d datafile handles (coll_id = %d, "
                 "handle = %llu, key = %s (%d), val_buf = %p (%d))\n",
		 dfile_count, s_op->u.listattr.fs_id,
		 llu(*handle), (char *)s_op->key.buffer,
		 s_op->key.buffer_sz, s_op->val.buffer,
		 s_op->val.buffer_sz);

    ret = job_trove_keyval_read(
        s_op->u.listattr.fs_id, *handle,
        &s_op->key, &s_op->val, 
        0, NULL, smcb, 0, js_p,
        &i, server_job_context);

    return ret;
}

static PINT_sm_action listattr_read_metafile_distribution_if_required(
    struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_server_op *s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    int ret = -PVFS_EINVAL;
    job_id_t i;
    PVFS_object_attr *resp_attr = NULL;
    PVFS_handle *handle = NULL;

    resp_attr = &s_op->resp.u.listattr.attr[s_op->u.listattr.handle_index];
    handle    = &s_op->u.listattr.handles[s_op->u.listattr.handle_index];

    assert(resp_attr->objtype == PVFS_TYPE_METAFILE);

    js_p->error_code = 0;

    /* if we don't need to fill in the distribution, skip it */
    if (!(s_op->u.listattr.attrmask & PVFS_ATTR_META_DIST))
    {
        gossip_debug(GOSSIP_LISTATTR_DEBUG, "skipping data handle "
                     "distribution read\n");
        return SM_ACTION_COMPLETE;
    }

    s_op->key.buffer = Trove_Common_Keys[METAFILE_DIST_KEY].key;
    s_op->key.buffer_sz = Trove_Common_Keys[METAFILE_DIST_KEY].size;

    /*
      there *should* be some distribution information.  if not, dump
      which handle is busted and assertion die for now while we're not
      handling this kind of error
    */
    if (resp_attr->u.meta.dist_size < 1)
    {
        gossip_err("Cannot Read Dist!  Got an invalid dist size for "
                   "handle %llu,%d\n",llu(*handle),
                   s_op->u.listattr.fs_id);
        js_p->error_code = -PVFS_EINVAL;
        return SM_ACTION_COMPLETE;
    }
    assert(resp_attr->u.meta.dist_size > 0);

    /* add mask value to indicate the distribution is filled */
    resp_attr->mask |= PVFS_ATTR_META_DIST;

    s_op->val.buffer_sz = resp_attr->u.meta.dist_size; 
    s_op->val.buffer = malloc(s_op->val.buffer_sz);
    if (!s_op->val.buffer)
    {
        gossip_err("Cannot allocate dist of size %d\n",
                   s_op->val.buffer_sz);
	js_p->error_code = -PVFS_ENOMEM;
	return SM_ACTION_COMPLETE;
    }

    ret = job_trove_keyval_read(
        s_op->u.listattr.fs_id, *handle,
        &(s_op->key), &(s_op->val), 
        0, NULL,
        smcb, 0, js_p, &i, server_job_context);

    return ret;
}

static PINT_sm_action listattr_setup_resp(struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_server_op *s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    PVFS_object_attr *resp_attr;
    PVFS_handle *handle;
    int *resp_error;
    
    handle    = &s_op->u.listattr.handles[s_op->u.listattr.handle_index];
    resp_error = &s_op->resp.u.listattr.error[s_op->u.listattr.handle_index];
    resp_attr = &s_op->resp.u.listattr.attr[s_op->u.listattr.handle_index++];
    s_op->u.listattr.nhandles--;


    gossip_debug(
        GOSSIP_LISTATTR_DEBUG,
        "- RETURNING retrieved attrs: [owner = %d, group = %d\n\t"
        "perms = %o, type = %d, atime = %llu, mtime = %llu\n\t"
        "ctime = %llu, dfile_count = %d, dist_size = %d]\n",
        resp_attr->owner, resp_attr->group, resp_attr->perms,
        resp_attr->objtype, llu(resp_attr->atime),
        llu(resp_attr->mtime), llu(resp_attr->ctime),
        (int)resp_attr->u.meta.dfile_count,
        (int)resp_attr->u.meta.dist_size);

    *resp_error = 0;
    if (resp_attr->objtype == PVFS_TYPE_METAFILE)
    {
        if (js_p->error_code == 0)
        {
            if (resp_attr->mask & PVFS_ATTR_META_DFILES)
            {
                if (resp_attr->u.meta.dfile_count)
                {
                    assert(resp_attr->u.meta.dfile_array);
                }
                gossip_debug(GOSSIP_LISTATTR_DEBUG,
                             "  also returning %d datafile handles\n",
                             resp_attr->u.meta.dfile_count);
            }

            if (resp_attr->mask & PVFS_ATTR_META_DIST)
            {
                PINT_dist_decode(&resp_attr->u.meta.dist, s_op->val.buffer);
                free(s_op->val.buffer);

                if(resp_attr->u.meta.dist == 0) {
                    gossip_err("Found dist of 0 for handle %llu,%d\n",
                            llu(*handle), s_op->u.listattr.fs_id);
                    PVFS_perror("Metafile listattr_setup_resp",js_p->error_code);
                    *resp_error = -PVFS_EIO;
                    js_p->error_code = s_op->u.listattr.nhandles == 0 ? 0 : MORE_WORK;
                    return SM_ACTION_COMPLETE;
                }
                
                gossip_debug(GOSSIP_LISTATTR_DEBUG,
                             "  also returning dist size of %d\n",
                             resp_attr->u.meta.dist_size);
            }
        }
        else {
            PVFS_perror("Metafile listattr_setup_resp", js_p->error_code);
            *resp_error = js_p->error_code;
            js_p->error_code = s_op->u.listattr.nhandles == 0 ? 0 : MORE_WORK;
            return SM_ACTION_COMPLETE;
        }
    }
    else if ((resp_attr->objtype == PVFS_TYPE_DATAFILE) &&
             (resp_attr->mask & PVFS_ATTR_DATA_SIZE))
    {
        if (js_p->error_code == 0)
        {
            gossip_debug(GOSSIP_LISTATTR_DEBUG,
                         "  also returning data size of %lld\n",
                         lld(resp_attr->u.data.size));
        }
        else {
            PVFS_perror("Datafile listattr_setup_resp", js_p->error_code);
            *resp_error = js_p->error_code;
            js_p->error_code = s_op->u.listattr.nhandles == 0 ? 0 : MORE_WORK;
            return SM_ACTION_COMPLETE;
        }
    }
    else if ((resp_attr->objtype == PVFS_TYPE_SYMLINK) &&
             (resp_attr->mask & PVFS_ATTR_SYMLNK_TARGET))
    {
        if (js_p->error_code == 0)
        {
            assert(resp_attr->u.sym.target_path);
            assert(resp_attr->u.sym.target_path_len);
            /*
              adjust target path len down to actual size ; always
              include the null termination char in the target_path_len
            */
            resp_attr->u.sym.target_path_len =
                (strlen(resp_attr->u.sym.target_path) + 1);

            gossip_debug(GOSSIP_LISTATTR_DEBUG,
                         "  also returning link target of %s (len %d)\n",
                         resp_attr->u.sym.target_path,
                         resp_attr->u.sym.target_path_len);
        }
        else
        {
            gossip_err("Failed to retrieve symlink target path for "
                       "handle %llu,%d\n",llu(*handle),
                       s_op->u.listattr.fs_id);
            PVFS_perror("Symlink retrieval failure",js_p->error_code);

            *resp_error = js_p->error_code;
            js_p->error_code = s_op->u.listattr.nhandles == 0 ? 0 : MORE_WORK;
            return SM_ACTION_COMPLETE;
        }
    }

    gossip_debug(GOSSIP_LISTATTR_DEBUG,"@ End %s attributes: sending "
                 "status %d (error = %d)\n",
                 PINT_util_get_object_type(resp_attr->objtype),
		 s_op->resp.status, js_p->error_code);

#if 0
    gossip_debug(GOSSIP_LISTATTR_DEBUG, "returning attrmask ");
    PINT_attrmask_print(GOSSIP_LISTATTR_DEBUG,
                        resp_attr->mask);
#endif
    js_p->error_code = s_op->u.listattr.nhandles == 0 ? 0 : MORE_WORK;
    return SM_ACTION_COMPLETE;
}

static PINT_sm_action listattr_cleanup(struct PINT_smcb *smcb, job_status_s *js_p)
{
    int i;
    struct PINT_server_op *s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);

    if (s_op->u.listattr.attr_a)
    {
        for (i = 0; i < s_op->req->u.listattr.nhandles; i++) {
            PINT_free_object_attr(&s_op->u.listattr.attr_a[i]);
        }
        free(s_op->u.listattr.attr_a);
    }
    if (s_op->u.listattr.ds_attr_a)
        free(s_op->u.listattr.ds_attr_a);
    if (s_op->u.listattr.errors) 
        free(s_op->u.listattr.errors);
    return(server_state_machine_complete(smcb));
}

static PINT_sm_action listattr_setup_op(
    struct PINT_smcb *smcb, job_status_s *js_p)
{
    int ret;
    struct PINT_server_op *s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    job_id_t tmp_id;

    s_op->u.listattr.handles = s_op->req->u.listattr.handles;
    s_op->u.listattr.fs_id = s_op->req->u.listattr.fs_id;
    s_op->u.listattr.attrmask = s_op->req->u.listattr.attrmask;
    s_op->resp.u.listattr.nhandles = s_op->u.listattr.nhandles = s_op->req->u.listattr.nhandles;
    s_op->u.listattr.handle_index = 0;
    s_op->u.listattr.attr_a = (PVFS_object_attr *)
        calloc(s_op->u.listattr.nhandles * sizeof(PVFS_object_attr), 1);
    if (s_op->u.listattr.attr_a == NULL) {
        js_p->error_code = -PVFS_ENOMEM;
        return SM_ACTION_COMPLETE;
    }
    s_op->u.listattr.ds_attr_a = (PVFS_ds_attributes *) 
        calloc(s_op->u.listattr.nhandles * sizeof(PVFS_ds_attributes), 1);
    if (s_op->u.listattr.ds_attr_a == NULL) {
        js_p->error_code = -PVFS_ENOMEM;
        return SM_ACTION_COMPLETE;
    }
    s_op->u.listattr.errors = (PVFS_error *) 
        calloc(s_op->u.listattr.nhandles * sizeof(PVFS_error), 1);
    if (s_op->u.listattr.errors  == NULL) {
        js_p->error_code = -PVFS_ENOMEM;
        return SM_ACTION_COMPLETE;
    }
    /* Listattr response has to be allocated extra memory */
    s_op->resp.u.listattr.error = (PVFS_error *)
        calloc(s_op->u.listattr.nhandles * sizeof(PVFS_error), 1);
    if (s_op->resp.u.listattr.error == NULL) {
        js_p->error_code = -PVFS_ENOMEM;
        return SM_ACTION_COMPLETE;
    }
    s_op->resp.u.listattr.attr = (PVFS_object_attr *)
        calloc(s_op->u.listattr.nhandles * sizeof(PVFS_object_attr), 1);
    if (s_op->resp.u.listattr.attr == NULL) {
        js_p->error_code = -PVFS_ENOMEM;
        return SM_ACTION_COMPLETE;
    }
    js_p->error_code = 0;
    /* initiate retrieval of the attributes from the dspace */
    ret = job_trove_dspace_getattr_list(
            s_op->u.listattr.fs_id,
            s_op->u.listattr.nhandles,
            s_op->u.listattr.handles,
            smcb,
            s_op->u.listattr.errors,
            s_op->u.listattr.ds_attr_a,
            0,
            js_p,
            &tmp_id,
            server_job_context);

    return ret;
}

static PINT_sm_action listattr_get_dirent_count(
    struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_server_op *s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    int ret;
    job_id_t tmp_id;
    PVFS_handle *handle = NULL;

    handle    = &s_op->u.listattr.handles[s_op->u.listattr.handle_index];

    js_p->error_code = 0;

    ret = job_trove_keyval_get_handle_info(
            s_op->u.listattr.fs_id,
            *handle,
            TROVE_KEYVAL_HANDLE_COUNT,
            &s_op->u.listattr.keyval_handle_info,
            smcb,
            0,
            js_p,
            &tmp_id,
            server_job_context);

    return ret;
}

static PINT_sm_action listattr_interpret_dirent_count(
    struct PINT_smcb *smcb, job_status_s *js_p)
{
    struct PINT_server_op *s_op = PINT_sm_frame(smcb, PINT_FRAME_CURRENT);
    PVFS_object_attr *resp_attr = NULL;

    /* from the keyval_handle_info, retrieve the dirent_count */
    s_op->u.listattr.dirent_count = s_op->u.listattr.keyval_handle_info.count;
    resp_attr = &s_op->resp.u.listattr.attr[s_op->u.listattr.handle_index];
    resp_attr->u.dir.dirent_count = s_op->u.listattr.dirent_count;

    gossip_debug(GOSSIP_LISTATTR_DEBUG, "listattr: dirent_count: %lld\n",
        lld(resp_attr->u.dir.dirent_count));

    js_p->error_code = 0;
    return SM_ACTION_COMPLETE;
}

/*
 * Local variables:
 *  mode: c
 *  c-indent-level: 4
 *  c-basic-offset: 4
 * End:
 *
 * vim: ft=c ts=8 sts=4 sw=4 expandtab
 */

